#include "Essentials.h"
#include "Filing.h"
#include "Ready Menus.h"

Boolean FindProcess(unsigned long type, OSType signature, ProcessSerialNumber* process)
{
	Error				error;
	ProcessInfoRec		processInfo;
	
	process->highLongOfPSN=0; // so GetNextProcess retries first one
	process->lowLongOfPSN=kNoProcess;
	processInfo.processInfoLength=sizeof(processInfo); // param block vagaries
	processInfo.processName=0;
	processInfo.processAppSpec=0;
	
	while (1) {
		error=GetNextProcess(process); // Get the next process
			_i(error); // if none left, we've failed to find it
			
		error=GetProcessInformation(process, &processInfo); // find out about it
			_i(error);
			
		if ((processInfo.processType==type)&&(processInfo.processSignature==signature))
			return true;
	}

	_e
	return false;
}

Error GetFinderProcess(ProcessSerialNumber* process, Boolean* isPathFinder)
{
	Error		error;
	
	error=0;
	
	if (FindProcess('FNDR', 'MACS', process)) {
		if (isPathFinder)
			*isPathFinder=false;
	
	} else if (FindProcess('APPL', 'PFdR', process)) {
		if (isPathFinder)
			*isPathFinder=true;
	
	} else
		error=procNotFound;
	
	TestError(error);
	
	return error;
}

//	All of this stuff is copied from Files.c in Drop Drawers

	Error DoFinderFilesToDesc(FinderAction action, AEDesc* doFiles, AEDesc* ontoDesc)
	{
		Error				error;
		ProcessSerialNumber	process;
		Boolean				isPathFinder, wasChanged;
		long				item, items;
		AppleEvent			event, reply;
		AEEventClass		eventClass;
		AEEventID			eventID;
		OSType				workType;
		AEDesc				workDesc, otherDesc, windowDesc, appDesc;
		AEKeyword			keyword;
		Size				descSize;
		AliasHandle			aliasHandle;
		FSRef				fileRef;
		LSItemInfoRecord	itemInfo;
	
		error=GetFinderProcess(&process, &isPathFinder);
			_i(error);
			
		if (isPathFinder&&(doFiles->descriptorType==typeAEList)&&
				((action==finderGetInfo)||(action==finderReveal))) {
	
			error=AECountItems(doFiles, &items);
				_i(error)
			
			for (item=1; item<=items; item++) {
				error=AEGetNthDesc(doFiles, item, typeWildCard, &keyword, &workDesc);
					_i(error)
				error=DoFinderFilesToDesc(action, &workDesc, ontoDesc);
				AEDisposeDesc(&workDesc);
					_i(error)
			}
			
			_g
		}
	
		if ((action==finderReveal)||(action==finderGetInfo))
			BringFinderToFront();
		
		error=AECreateDesc(typeProcessSerialNumber, &process, sizeof(process), &appDesc);
			_i(error)
	
		if ((action==finderGetInfo)&&!isPathFinder) { // 1.5.9 OS X info windows are an entirely different kettle of fish
			
		//	create object descriptor for information window of required item
		
			error=AECreateList(0, 0, true, &workDesc);
				_i2(error)
	
			workType=formPropertyID;
			error=AEPutKeyPtr(&workDesc, keyAEKeyForm, typeEnumerated, &workType, sizeof(workType));
				_i6(error) // object descriptor of property form
			
			workType=typeProperty;
			error=AEPutKeyPtr(&workDesc, keyAEDesiredClass, typeType, &workType, sizeof(workType));
				_i6(error) // I want a property...
			
			workType=cInfoWindow;
			error=AEPutKeyPtr(&workDesc, keyAEKeyData, typeType, &workType, sizeof(workType));
				_i6(error) // of this type...
			
			// starting object description for source of outer object descriptor
			
			error=AECreateList(0, 0, true, &otherDesc);
				_i6(error)
	
			workType=formAbsolutePosition;
			error=AEPutKeyPtr(&otherDesc, keyAEKeyForm, typeEnumerated, &workType, sizeof(workType));
				_i7(error) // object descriptor of property form
			
			error=AEGetNthDesc(doFiles, 1, typeAlias, &keyword, &windowDesc); // this can only be done for one file chosen
				_i7(error)
			
			// all of the below is to make sure we give it a disk, folder or file type for the Apple Event (absurd)
			
			descSize=AEGetDescDataSize(&windowDesc);
			
			aliasHandle=(AliasHandle)NewHandle(descSize);
			HLock((Handle)aliasHandle);
			error=AEGetDescData(&windowDesc, *(Handle)aliasHandle, descSize);
			HUnlock((Handle)aliasHandle);
				_i7(error)
				
			error=FSResolveAliasWithMountFlags(NULL, aliasHandle, &fileRef, &wasChanged, kResolveAliasFileNoUI);
				_i7(error)
				
			DisposeHandle((Handle)aliasHandle);
				
			error=LSCopyItemInfoForRef(&fileRef, kLSRequestBasicFlagsOnly, &itemInfo);
				_i7(error)
			
			// Now we finally know what type of item it is
			
			workType=(itemInfo.flags&kLSItemInfoIsVolume) ? cDisk : (((itemInfo.flags&kLSItemInfoIsContainer)&&!(itemInfo.flags&kLSItemInfoIsPackage)) ? cFolder : cFile);
			error=AEPutKeyPtr(&otherDesc, keyAEDesiredClass, typeType, &workType, sizeof(workType));
				_i7(error) // I want a property...
				
			error=AEPutKeyDesc(&otherDesc, keyAEKeyData, &windowDesc);
			AEDisposeDesc(&windowDesc); // windowDesc is being used for the single item from the list
				_i7(error)
				
			error=AEPutKeyPtr(&otherDesc, keyAEContainer, typeNull, 0, 0);
				_i7(error)
			
			error=AECoerceDesc(&otherDesc, cObjectSpecifier, &windowDesc);
				_i7(error)
			
			// Finished inner object specifier, now including into outer as the container
			
			error=AEPutKeyDesc(&workDesc, keyAEContainer, &windowDesc);
			AEDisposeDesc(&windowDesc); // windowDesc is being used for the object descriptor
				_i7(error) // belonging to...
			
			error=AECoerceDesc(&workDesc, cObjectSpecifier, &windowDesc);
				
			_e7
			AEDisposeDesc(&otherDesc);
			_e6
			AEDisposeDesc(&workDesc);
				_i2(error);
	
		//	send open Apple Event for the object
		
			error=AECreateAppleEvent(kCoreEventClass, kAEOpen, &appDesc, kAutoGenerateReturnID, kAnyTransactionID, &event);
				_i4(error)
				
			error=AEPutParamDesc(&event, keyDirectObject, &windowDesc); // shove the file data in
				_i5(error);
			
			error=AESend(&event, &reply, kAENoReply, kAENormalPriority, 1200, nil, nil);
			
			AEDisposeDesc(&reply);
			
			AEDisposeDesc(&event);
			
		//	send select Apple Event for the object
		
			error=AECreateAppleEvent(kCoreEventClass, kAESelect, &appDesc, kAutoGenerateReturnID, kAnyTransactionID, &event);
				_i4(error)
				
			error=AEPutParamDesc(&event, keyDirectObject, &windowDesc); // shove the file data in
				_i5(error);
			
			error=AESend(&event, &reply, kAENoReply, kAENormalPriority, 1200, nil, nil);
			
			AEDisposeDesc(&reply);
			
			_e5
			AEDisposeDesc(&event);
	
		//	dispose of the descriptor
		
			_e4
			AEDisposeDesc(&windowDesc);
		
		} else {
		
		//	prepare the event type from the desired action
	
			switch (action) {
				case finderOpen: case finderOpenIn:
					if (isPathFinder) {
						eventClass='PFdR';
						eventID='odoC';
					} else {
						eventClass=kCoreEventClass;
						eventID=kAEOpen;
					}
					break;
	
				case finderReveal:
					eventClass=kAEMiscStandards;
					eventID=kAEMakeObjectsVisible;
					break;
	
				case finderCopyTo:
					eventClass=kAECoreSuite;
					eventID=kAEClone;
					break;
	
				case finderMoveTo:
					eventClass=kAECoreSuite;
					eventID=kAEMove;
					break;
	
				case finderGetInfo:
					if (isPathFinder) {
						eventClass='PFdR';
						eventID='Info';
					} else {
						eventClass=kAEFinderEvents;
						eventID=kAEGetInfoSelection; // this is an old-style Finder Event but hey-ho it still works on OS 9
					}
					break;
			}
	
		//	create initial apple event
	
			error=AECreateAppleEvent(eventClass, eventID, &appDesc, kAutoGenerateReturnID, kAnyTransactionID, &event);
				_i2(error)
			
		/*	
			Old method for getting info with an object specifier
	
			if (action==finderGetInfo) {
	
				error=AECreateList(0, 0, true, &workDesc);
					_i(error)
	
				workType=formPropertyID;
				error=AEPutKeyPtr(&workDesc, keyAEKeyForm, typeEnumerated, &workType, sizeof(workType));
					_i3(error) // object descriptor of property form
				
				workType=typeProperty;
				error=AEPutKeyPtr(&workDesc, keyAEDesiredClass, typeType, &workType, sizeof(workType));
					_i3(error) // I want a property...
				
				workType=cInfoWindow;
				error=AEPutKeyPtr(&workDesc, keyAEKeyData, typeType, &workType, sizeof(workType));
					_i3(error) // of this type...
					
				error=AEPutKeyDesc(&workDesc, keyAEContainer, doFiles);
					_i3(error) // belonging to...
				
				error=AEPutParamDesc(&event, keyDirectObject, &workDesc); // shove the file data in
				_e3
				AEDisposeDesc(&workDesc);
				_i2(error)
			
			}
		*/
	
		//	add direct parameter
	
			error=AEPutParamDesc(&event, keyDirectObject, doFiles); // shove the file data in
				_i3(error);
							
		//	if opening onto, add app to open onto - if copying to, add folder to copy into
				
			if (action==finderOpenIn) {
				Assert(ontoDesc);
				error=AEPutKeyDesc(&event, keyAEUsing, ontoDesc); // usin = the file spec
					_i3(error);
			}
	
			if ((action==finderCopyTo)||(action==finderMoveTo)) {
				Assert(ontoDesc);
				error=AEPutKeyDesc(&event, keyAEInsertHere, ontoDesc);
					_i3(error)
			}
				
		//	if getting info, we need to add a selection parameter
			
			if ((action==finderGetInfo)&&!isPathFinder)
				error=AEPutParamDesc(&event, keyOldFinderItems, doFiles); // add the files as a selection
		
		//	send the event
	
			error=AESend(&event, &reply, kAENoReply, kAENormalPriority, 1200, nil, nil);
	
		//	clear up afterwards
	
			AEDisposeDesc(&reply);
				
			_e3
			AEDisposeDesc(&event);
		}
		
		_e2
		AEDisposeDesc(&appDesc);
		_e
		return error;
	}
	
	Error DoFinderFiles(FinderAction action, AEDesc* doFiles, FSSpec* ontoFile)
	{
		Error		error;
		AEDesc		ontoDesc, *passDescPtr;
		
		if ((action==finderCopyTo)||(action==finderMoveTo)||(action==finderOpenIn))
			passDescPtr=&ontoDesc;
		else
			passDescPtr=0;
			
		if (passDescPtr) {
			Assert(ontoFile);
			error=CreateFileDesc(ontoFile, passDescPtr);
				_i(error)
		}
		
		error=DoFinderFilesToDesc(action, doFiles, passDescPtr);
		
		if (passDescPtr)
			AEDisposeDesc(passDescPtr);
		
		_e
		return error;
	}
	
	Error DoFinderFile(FinderAction action, FSSpec* _doFile, FSSpec* ontoFile)
	{
		Error				error;
		FSSpec				openFileSpec;
		Boolean				isFolder, isAlias;
		AEDesc				listDesc;
		FSRef				fileRef;
		LSItemInfoRecord	itemInfo;
				
		openFileSpec=*_doFile;
		
		// the OS X 10.1.x Finder will not mount a disk when it is sent an Apple event
		// to open an alias pointing to that disk. So we need to do it ourselves
		
		ResolveAliasFile(&openFileSpec, true, &isFolder, &isAlias);
		
		error=AECreateList(0, 0, false, &listDesc);
			_i(error)
		error=AddFileToAEList(&openFileSpec, &listDesc); // add the item to the list
			_i2(error)
		error=DoFinderFiles(action, &listDesc, ontoFile);
			_i2(error)
		
		// since Finder no longer brought to front for finderOpen, test for folder or disk case
		
		if ((action==finderOpen)&&isFolder) {
			if (FSpMakeFSRef(&openFileSpec, &fileRef)==0)
				if (LSCopyItemInfoForRef(&fileRef, kLSRequestBasicFlagsOnly, &itemInfo)==0)
					if ((itemInfo.flags&kLSItemInfoIsContainer)&&!(itemInfo.flags&kLSItemInfoIsPackage))
						BringFinderToFront();
		}
		
		_e2
		AEDisposeDesc(&listDesc);
		_e
		return error;
	}

	Error CreateFileDesc(const FSSpec* file, AEDesc* fileDesc)
	{
		AliasHandle		alias;
		OSErr			error;
		
		error=NewAliasMinimal(file, &alias);
			_i(error)
		
		HLock((Handle)alias);
		error=AECreateDesc(typeAlias, *alias, GetHandleSize((Handle)alias), fileDesc);
		HUnlock((Handle)alias);
		
		DisposeHandle((Handle)alias);
		
		_e
		return error;
	}

	Error AddFileToAEList(const FSSpec* file, AEDesc* listDesc)
	{
		OSErr		error;
		AEDesc		fileDesc;
		
		error=CreateFileDesc(file, &fileDesc);
			_i(error)
		
		error=AEPutDesc(listDesc, 0, &fileDesc);
		
		AEDisposeDesc(&fileDesc);
		
		_e
		return error;
	}

Error BringFinderToFront()
{
	Error				error;
	ProcessSerialNumber	process;
	
	error=GetFinderProcess(&process, NULL);
		_i(error);
		
	SetFrontProcess(&process);

	_e
    return error;
}

Error CreateAlias(FSSpec* fromFile, FSSpec *intoFolder)
{
	Error				error;
	AEDesc				workDesc;
	AppleEvent			event, reply;
	OSType				workType;
	
	Assert(fromFile);
	Assert(intoFolder);

//	create event

	workType='MACS';
	error=AECreateDesc(typeApplSignature, &workType, sizeof(workType), &workDesc);
		_i(error)
	
	error=AECreateAppleEvent(kAECoreSuite, kAECreateElement, &workDesc,
		kAutoGenerateReturnID, kAnyTransactionID, &event);
	AEDisposeDesc(&workDesc);
		_i(error)
	
//	kocl = type 'alis'

	workType=typeAlias;
	error=AEPutKeyPtr(&event, keyAEObjectClass, typeType, &workType, sizeof(workType));
		_i2(error);

//	insh = the file spec

	error=AEPutKeyPtr(&event, keyAEInsertHere, typeFSS, intoFolder, sizeof(FSSpec));
		_i2(error);

//	to   = the file spec

	error=AEPutKeyPtr(&event, keyASPrepositionTo, typeFSS, fromFile, sizeof(FSSpec));
		_i2(error);
		
//	send the apple event

	error=AESend(&event, &reply, kAENoReply, kAENormalPriority, 1200, nil, nil);
	AEDisposeDesc(&reply);
	_e2
	AEDisposeDesc(&event);
	_e
	return error;
}

Boolean SelectNewFolder(FSSpec* fileSpec)
{
    Boolean				result, isFolder, isAlias;
    Error				error;
    AEDesc				defaultLocation, selection;
    NavDialogOptions	options;
    NavReplyRecord		reply;
	ProcessSerialNumber	process;
	
	BeginUserInteraction(&process);
    
    result=false;
    
    error=AECreateDesc(typeFSS, fileSpec, sizeof(FSSpec), &defaultLocation);
        TestError(error);
        _i(error)
    
    error=NavGetDefaultDialogOptions(&options);
        TestError(error);
        _i2(error)
    
    options.dialogOptionFlags&=~kNavAllowMultipleFiles;
    error=NavChooseFolder(&defaultLocation, &reply, &options, NULL, NULL, NULL);
    /*
        TestError(error); // could be user cancelled error
    */
        _i2(error)
    
    if (reply.validRecord) {
        error=AECoerceDesc(&reply.selection, typeFSS, &selection);
            TestError(error);
            _i3(error)
            
        Assert(selection.descriptorType==typeFSS);
    
       	error=AEGetDescData(&selection, fileSpec, sizeof(FSSpec));
        AEDisposeDesc(&selection);
            TestError(error);
            _i3(error)
        
        ResolveAliasFile(fileSpec, true, &isFolder, &isAlias);
        
        result=true;
    }
    
    _e3
    NavDisposeReply(&reply);
    _e2
    AEDisposeDesc(&defaultLocation);
    _e
	EndUserInteraction(&process);

    return result;
}

Boolean SelectAnObject(FSSpec* fileSpec)
{
    Boolean				result;
    Error				error;
    AEDesc				selection;
    NavDialogOptions	options;
    NavReplyRecord		reply;
	ProcessSerialNumber	process;
    
    BeginUserInteraction(&process);
	
	result=false;
    
    error=NavGetDefaultDialogOptions(&options);
        TestError(error);
        _i2(error)
    
    options.dialogOptionFlags&=~kNavAllowMultipleFiles;
    options.dialogOptionFlags|=kNavSupportPackages;
    error=NavChooseObject(NULL, &reply, &options, NULL, NULL, NULL);
/*
        TestError(error); // could be user cancelled error
*/
        _i2(error)
    
    if (reply.validRecord) {
        error=AECoerceDesc(&reply.selection, typeFSS, &selection);
            TestError(error);
            _i3(error)
            
        Assert(selection.descriptorType==typeFSS);
    
       	error=AEGetDescData(&selection, fileSpec, sizeof(FSSpec));
        AEDisposeDesc(&selection);
            TestError(error);
            _i3(error)
        
        result=true;
    }
    
    _e3
    NavDisposeReply(&reply);
    _e2
    EndUserInteraction(&process);
	
	return result;
}