#if TARGET_RT_LITTLE_ENDIAN // we need the translation layer

	#define LoadShort(x)			EndianS16_BtoN(x)
	#define SaveShort(x)			EndianS16_NtoB(x)

	#define LoadUnsignedShort(x)	EndianU16_BtoN(x)
	#define SaveUnsignedShort(x)	EndianU16_NtoB(x)
	
	#define LoadLong(x)				EndianS32_BtoN(x)
	#define SaveLong(x)				EndianS32_NtoB(x)

	#define LoadUnsignedLong(x)		EndianU32_BtoN(x)
	#define SaveUnsignedLong(x)		EndianU32_NtoB(x)
	
#else // pass values straight through, so also compatible with old versions of API
	
	#define LoadShort(x)			(x)
	#define SaveShort(x)			(x)
	
	#define LoadUnsignedShort(x)	(x)
	#define SaveUnsignedShort(x)	(x)
	
	#define LoadLong(x)				(x)
	#define SaveLong(x)				(x)

	#define LoadUnsignedLong(x)		(x)
	#define SaveUnsignedLong(x)		(x)
	
#endif


#define ToLoadShort(x)				(x)=LoadShort(x)
#define ToSaveShort(x)				(x)=SaveShort(x)

#define ToLoadUnsignedShort(x)		(x)=LoadUnsignedShort(x)
#define ToSaveUnsignedShort(x)		(x)=SaveUnsignedShort(x)

#define ToLoadLong(x)				(x)=LoadLong(x)
#define ToSaveLong(x)				(x)=SaveLong(x)

#define ToLoadUnsignedLong(x)		(x)=LoadUnsignedLong(x)
#define ToSaveUnsignedLong(x)		(x)=SaveUnsignedLong(x)


#define OSTypeToChars(o, c)			(*(unsigned long*)(c)=SaveUnsignedLong(o))
#define CharsToOSType(c, o)			(o)=LoadUnsignedLong(*(unsigned long*)(c))