enum {
    menuTypeNone='none',
    menuTypeFolder='fold',
    menuTypeProcess='proc',
    menuTypeRecentProcess='rpro'
};

enum {
    menuIconClassicApple='clap',
    menuIconHardDisk='hadi',
    menuIconFolder='fldr',
    menuIconApplication='appl',
    menuIconInternet='inet',
    menuIconCurrentApplication='cuap' // changes automatically
};

enum {
    sideLeftMenuBar='left',
    sideRightMenuBar='rght'
};

enum {
    colorBlue='blue',
    colorRed='red ',
    colorGreen='gren',
    colorGraphite='grap',
	colorRainbow='rbow'
};

enum {
    showSystemWhenModifierDown=1,
    showSystemWhenMouseWithin=2,
	showSystemWhenModifierUp=3
};

enum {
    mouseWithinLeft='left',
    mouseWithinRight='rght',
    mouseWithinTop='top ',
    mouseWithinBottom='bott',
    mouseWithinInside='cntr',
    mouseWithinOutside='outs'
};

// Whenever any fields are added to these structures, it is crucial to add
// the relevant lines in the ToLoad* and ToSave* functions for endian issues

typedef struct MenuSpec MenuSpec;

struct MenuSpec {
    MenuSpec	*next;

    OSType		side; // on each side, menus go in order of the linked list
    OSType		type;
    OSType		icon;
    FSSpec		file; // only relevant for some menu types
};

typedef struct {
    OSType		color;
    short		showSystemWhen;
    short		modifierKey; // use standard system key codes
    OSType		mouseWithin;
} AppleMenuSettings;

typedef struct {
	short		openAtStartup;
	short		finderFrontStartup;
	short		showIconsMainMenu;
	short		showIconsSubmenus;
	short		submenuIconLimit;
} GeneralSettings;

typedef struct {
    Str255			name;
    unsigned long	code;
    unsigned long	dateStamp;
} Registration;

void		ToLoadMenuSpec(MenuSpec* spec);
void		ToSaveMenuSpec(MenuSpec* spec);
void		ToLoadAppleMenuSettings(AppleMenuSettings* settings);
void		ToSaveAppleMenuSettings(AppleMenuSettings* settings);
void		ToLoadGeneralSettings(GeneralSettings* settings);
void		ToSaveGeneralSettings(GeneralSettings* settings);
void		ToLoadRegistration(Registration* registration);
void		ToSaveRegistration(Registration* registration);

Error		LoadPreferences(); // loads defaults if all else fails
Error		SavePreferences();
void		ShowPreferencesDialog();
void		ApplyOpenAtStartupSetting();

MenuSpec*	AddMenuToPreferences(Error* error, OSType side, OSType type, OSType icon, FSSpec* file);
                // adds to end of list, i.e. more inner icons
void		RemoveMenuFromPreferences(MenuSpec* menuSpec);



extern MenuSpec				*firstMenuSpec;
extern unsigned long		selectionCount;
extern Registration			registration;
extern short				registered;
extern Boolean				registrationToUpdate;
extern AppleMenuSettings	appleMenuSettings;
extern GeneralSettings		generalSettings;