#include "Preferences.h"

// A 'ready' menu is one which can be drawn, used, etc...

typedef struct ReadyMenu ReadyMenu;

struct ReadyMenu {
    ReadyMenu			*next;
    MenuSpec			*spec; // points directly to preferences structure
    MenuRef				menu; // cached for display
    
    WindowRef			window;
	Rect				rect;
	Boolean				appleMenuInvisibleFlag;
	FNSubscriptionRef	notifyRef;
};

OSStatus		InitialiseReadyMenus();
Error			RebuildReadyMenus(); // from MenuSpecs
void			RevisibleReadyMenus();
void			InvalidateReadyMenus();
void			ClearReadyMenus();
void			DestroyReadyMenus();

ReadyMenu*		AddReadyMenu(Error* error, MenuSpec* menuSpec);
void			RemoveReadyMenu(ReadyMenu* readyMenu);

void			ScreenInformationChanged();
void			ChangeReadyMenuFrontProcessIcon();

void			BeginUserInteraction(ProcessSerialNumber* priorProcess);
void			EndUserInteraction(const ProcessSerialNumber* priorProcess);

extern int			userInteractionHideLevel;
extern Boolean		classicFrontHideFlag; 
extern ReadyMenu	*firstReadyMenu;

void			InitializeFolderCachedMenu(ReadyMenu* readyMenu);
void			DestroyFolderCachedMenu(ReadyMenu* readyMenu);
void			ClickFolderMenu(Point globalPoint, ReadyMenu* readyMenu, DragReference dragRef);
void			SelectClassicMenuItem(short item);